# std::floor, std::floorf, std::floorl

From cppreference.com
< cpp‎ | numeric‎ | math

Defined in header `<cmath>` |  |
| (1) |
float floor ( float arg ); |  |
float floorf( float arg ); |  | (since C++11)
double floor ( double arg ); | (2) |
| (3) |
long double floor ( long double arg ); |  |
long double floorl( long double arg ); |  | (since C++11)
double floor ( IntegralType arg ); | (4) | (since C++11)

1-3) Computes the largest integer value not greater than `arg`.
4) A set of overloads or a function template accepting an argument of any integral type. Equivalent to 2) (the argument is cast to double).

### Parameters

arg | - | floating point value

### Return value

If no errors occur, the largest integer value not greater than `arg`, that is ⌊arg⌋, is returned.

Return value
Argument

### Error handling

Errors are reported as specified in math_errhandling.

If the implementation supports IEEE floating-point arithmetic (IEC 60559),

- The current rounding mode has no effect.
- If `arg` is ±∞, it is returned, unmodified
- If `arg` is ±0, it is returned, unmodified
- If arg is NaN, NaN is returned

### Notes

FE_INEXACT may be (but isn't required to be) raised when rounding a non-integer finite value.

The largest representable floating-point values are exact integers in all standard floating-point formats, so this function never overflows on its own; however the result may overflow any integer type (including std::intmax_t), when stored in an integer variable.

### Example

Run this code

    #include <cmath>
    #include <iostream>
    int main()
    {
        std::cout << std::fixed
                  << "floor(+2.7) = " << std::floor(+2.7) << '\n'
                  << "floor(-2.7) = " << std::floor(-2.7) << '\n'
                  << "floor(-0.0) = " << std::floor(-0.0) << '\n'
                  << "floor(-Inf) = " << std::floor(-INFINITY) << '\n';
    }

Output:

    floor(+2.7) = 2.000000
    floor(-2.7) = -3.000000
    floor(-0.0) = -0.000000
    floor(-Inf) = -inf

### See also

ceil ceilf ceill (C++11)(C++11) | nearest integer not less than the given value (function)
trunc truncf truncl (C++11)(C++11)(C++11) | nearest integer not greater in magnitude than the given value (function)
round roundf roundl lround lroundf lroundl llround llroundf llroundl (C++11)(C++11)(C++11)(C++11)(C++11)(C++11)(C++11)(C++11)(C++11) | nearest integer, rounding away from zero in halfway cases (function)

Retrieved from "https://en.cppreference.com/mwiki/index.php?title=cpp/numeric/math/floor&oldid=108267"